
{*****************************************}
{                                         }
{             FastReport v2.2             }
{         Designer's align window         }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}

unit FR_Align;

interface

{$I FR_Vers.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, FR_Ctrls, FR_Utils;

type
  TAlignForm = class(TSForm)
    ScrollBox1: TScrollBox;
    SpeedButton1: TfrSpeedButton;
    SpeedButton2: TfrSpeedButton;
    SpeedButton3: TfrSpeedButton;
    SpeedButton4: TfrSpeedButton;
    SpeedButton5: TfrSpeedButton;
    SpeedButton6: TfrSpeedButton;
    SpeedButton7: TfrSpeedButton;
    SpeedButton8: TfrSpeedButton;
    SpeedButton9: TfrSpeedButton;
    SpeedButton10: TfrSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AlignForm: TAlignForm;

implementation

{$R *.DFM}

uses FR_Desgn, FR_Class;

function Objects:TList;
begin
  Result := frDesigner.Page.Objects;
end;

function GetFirstSelected:TfrView;
begin
  if FirstSelected <> nil then
    Result := FirstSelected else
    Result := Objects[frGetTopSelected];
end;

function GetLeftObject:Integer;
var i: Integer;
    t: TfrView;
    x: Integer;
begin
  t := Objects[frGetTopSelected];
  x := t.x;
  Result := frGetTopSelected;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      if t.x < x then
      begin
        x := t.x;
        Result := i;
      end;
  end;
end;

function GetRightObject:Integer;
var i: Integer;
    t: TfrView;
    x: Integer;
begin
  t := Objects[frGetTopSelected];
  x := t.x+t.dx;
  Result := frGetTopSelected;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      if t.x+t.dx > x then
      begin
        x := t.x+t.dx;
        Result := i;
      end;
  end;
end;

function GetTopObject:Integer;
var i: Integer;
    t: TfrView;
    y: Integer;
begin
  t := Objects[frGetTopSelected];
  y := t.y;
  Result := frGetTopSelected;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      if t.y < y then
      begin
        y := t.y;
        Result := i;
      end;
  end;
end;

function GetBottomObject:Integer;
var i: Integer;
    t: TfrView;
    y: Integer;
begin
  t := Objects[frGetTopSelected];
  y := t.y+t.dy;
  Result := frGetTopSelected;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      if t.y+t.dy > y then
      begin
        y := t.y+t.dy;
        Result := i;
      end;
  end;
end;

procedure TAlignForm.FormShow(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or
    SWP_NOSIZE or SWP_NOACTIVATE);
end;

procedure TAlignForm.SpeedButton1Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    x: Integer;
begin
  if SelNum < 2 then Exit;
  t := GetFirstSelected;
  x := t.x;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      t.x := x;
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton6Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    y: Integer;
begin
  if SelNum < 2 then Exit;
  t := GetFirstSelected;
  y := t.y;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      t.y := y;
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton5Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    x: Integer;
begin
  if SelNum < 2 then Exit;
  t := GetFirstSelected;
  x := t.x+t.dx;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      t.x := x-t.dx;
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton10Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    y: Integer;
begin
  if SelNum < 2 then Exit;
  t := GetFirstSelected;
  y := t.y+t.dy;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      t.y := y-t.dy;
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton2Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    x: Integer;
begin
  if SelNum < 2 then Exit;
  t := GetFirstSelected;
  x := t.x + t.dx div 2;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      t.x := x - t.dx div 2;
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton7Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    y: Integer;
begin
  if SelNum < 2 then Exit;
  t := GetFirstSelected;
  y := t.y + t.dy div 2;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then
      t.y := y - t.dy div 2;
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton3Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    x: Integer;
begin
  if SelNum = 0 then Exit;
  t := Objects[GetLeftObject];
  x := t.x;
  t := Objects[GetRightObject];
  x := x + (t.x + t.dx - x - frDesigner.Page.PrnInfo.Pgw) div 2;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then Dec(t.x,x);
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton8Click(Sender: TObject);
var i: Integer;
    t: TfrView;
    y: Integer;
begin
  if SelNum = 0 then Exit;
  t := Objects[GetTopObject];
  y := t.y;
  t := Objects[GetBottomObject];
  y := y + (t.y + t.dy - y - frDesigner.Page.PrnInfo.Pgh) div 2;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then Dec(t.y,y);
  end;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton4Click(Sender: TObject);
var s: TStringList;
    i,dx: Integer;
    t: TfrView;
begin
  if SelNum < 3 then Exit;
  s := TStringList.Create;
  s.Sorted := True;
  s.Duplicates := dupAccept;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then s.AddObject(Format('%4.4d',[t.x]),t);
  end;
  dx := (TfrView(s.Objects[s.Count-1]).x - TfrView(s.Objects[0]).x) div (s.Count-1);
  for i := 1 to s.Count-2 do
    TfrView(s.Objects[i]).x := TfrView(s.Objects[i-1]).x + dx;
  s.Free;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

procedure TAlignForm.SpeedButton9Click(Sender: TObject);
var s: TStringList;
    i,dy: Integer;
    t: TfrView;
begin
  if SelNum < 3 then Exit;
  s := TStringList.Create;
  s.Sorted := True;
  s.Duplicates := dupAccept;
  for i := 0 to Objects.Count-1 do
  begin
    t := Objects[i];
    if t.Selected then s.AddObject(Format('%4.4d',[t.y]),t);
  end;
  dy := (TfrView(s.Objects[s.Count-1]).y - TfrView(s.Objects[0]).y) div (s.Count-1);
  for i := 1 to s.Count-2 do
    TfrView(s.Objects[i]).y := TfrView(s.Objects[i-1]).y + dy;
  s.Free;
  DesignerForm.RedrawPage;
  Preview.GetMultipleSelected;
end;

end.
