
{*****************************************}
{                                         }
{             FastReport v2.2             }
{               Memo editor               }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}

unit FR_Edit;

interface

{$I FR_Vers.inc}

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, StdCtrls, Buttons, ClipBrd, FR_Class, FR_Insp;

type
  TEditorForm = class(TPropEditor)
    M1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure M1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDeactivate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function ShowEditor:TModalResult; override;
  end;

var
  EditorForm: TEditorForm;

implementation

{$R *.DFM}

uses FR_Var, FR_Flds;

function TEditorForm.ShowEditor:TModalResult;
begin
  Result := mrCancel;
  if View <> nil then
    Result := inherited ShowEditor;
end;

procedure TEditorForm.FormActivate(Sender: TObject);
begin
  M1.Lines.Assign(View.Memo);
  M1.SetFocus;
end;

procedure TEditorForm.FormDeactivate(Sender: TObject);
begin
  if ModalResult = mrOk then View.Memo.Assign(M1.Lines);
end;

procedure TEditorForm.Button3Click(Sender: TObject);
begin
  VarForm := TVarForm.Create(nil);
  with VarForm do
  if ShowModal = mrOk then
  begin
    ClipBoard.Clear;
    if Variables.ItemIndex >= 0 then
      ClipBoard.AsText := '[' + Variables.Items[Variables.ItemIndex] + ']';
    M1.PasteFromClipboard;
  end;
  VarForm.Free;
  M1.SetFocus;
end;

procedure TEditorForm.M1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Insert) and (Shift = []) then Button3Click(Self);
  if Key = vk_Escape then ModalResult := mrCancel;
end;

procedure TEditorForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Return) and (ssCtrl in Shift) then
  begin
    ModalResult := mrOk;
    Key := 0;
  end;
end;

procedure TEditorForm.Button4Click(Sender: TObject);
begin
  FieldsForm := TFieldsForm.Create(nil);
  with FieldsForm do
  if ShowModal = mrOk then
  begin
    ClipBoard.Clear;
    ClipBoard.AsText := '[' + DBField + ']';
    M1.PasteFromClipboard;
  end;
  FieldsForm.Free;
  M1.SetFocus;
end;

end.
