
{*****************************************}
{                                         }
{             FastReport v2.2             }
{           Text export filter            }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}

unit FR_EText;

interface

{$I FR_Vers.inc}

uses
  SysUtils, Windows, Messages, Classes, Graphics, FR_Class, FR_Utils;

type
  TfrTextExportFilter = class(TfrExportFilter)
  private
    Lines: TStringList;
    CurY,MaxY: Integer;
  public
    constructor Create(AStream:TStream); override;
    destructor Destroy; override;
    procedure OnEndPage; override;
    procedure OnBeginPage; override;
    procedure OnText(x,y:Integer; const text:String; View:TfrView); override;
  end;



implementation


const
  UsedFont = 13;

function dup(aChar:Char; Count:Integer): string;
var i: Integer;
begin
  result := '';
  for i := 1 to Count do result := result + aChar;
end;

procedure WriteMemo(Stream:TStream; l:TStrings);
var s: String;
    i: Integer;
    b: Byte;
begin
  for i := 0 to l.Count-1 do
  begin
    s := l[i];
    if s <> '' then Stream.Write(s[1],Length(s));
    b := 13;
    Stream.Write(b,1);
    b := 10;
    Stream.Write(b,1);
  end;
end;

constructor TfrTextExportFilter.Create(AStream:TStream);
begin
  inherited Create(AStream);
  Lines := TStringList.Create;
end;

destructor TfrTextExportFilter.Destroy;
begin
  Lines.Free;
  inherited Destroy;
end;

procedure TfrTextExportFilter.OnEndPage;
var b: Byte;
    i: Integer;
begin
  i := Lines.Count-1;
  while Lines[i] = '' do
  begin
    Lines.Delete(i);
    Dec(i);
  end;
  WriteMemo(Stream,Lines);
  b := 12;
  Stream.Write(b,1);
  b := 13;
  Stream.Write(b,1);
  b := 10;
  Stream.Write(b,1);
end;

procedure TfrTextExportFilter.OnBeginPage;
var i: Integer;
begin
  Lines.Clear;
  for i := 0 to 200 do Lines.Add('');
  LastDataRow := -1;
end;

procedure TfrTextExportFilter.OnText(x,y:Integer; const text:String; View:TfrView);
var Line: string;
begin
  x := Round(x/(UsedFont/2));
  if DataRow <> -1 then
  begin
    if DataRow <> LastDataRow then
    begin
      if LastDataRow = -1 then MaxY := Round(y/(UsedFont+4))-1;
      CurY := MaxY+1;
      MaxY := CurY;
      LastTextRow := y;
      LastDataRow := DataRow;
    end;
    if DataRow = LastDataRow then
    begin
      if TextRow = 0 then
      begin
        y := CurY+Round((y-RowTop)/(FontHeight+2));
        LastTextRow := y;
      end
      else
        y := LastTextRow+TextRow;
      if MaxY < y then MaxY := y;
    end;
  end
  else
  begin
    if TextRow = 0 then
    begin
      y := Round(y/(UsedFont+4));
      LastTextRow := y;
    end
    else
      y := LastTextRow+TextRow;
  end;
  LastDataRow := DataRow;
  if text = '' then Exit;
  Line := Lines[y];
  if Length(Line) < x then
    Line := Line+Dup(' ',x-Length(Line));
  Delete(Line,x,Length(Text));
  Insert(Text,Line,x);
  Lines[y] := Line;
end;


initialization
  frRegisterExportFilter(TfrTextExportFilter,
    frLoadStr('STextFile') + ' (*.txt)','*.txt');

end.
