
{*****************************************}
{                                         }
{             FastReport v2.2             }
{        'Values' property editor         }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}

unit FR_Ev_ed;

interface

{$I FR_Vers.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FR_Class, ExtCtrls, DB, DsgnIntf, TypInfo, Buttons,
  FR_Ctrls, FR_Utils;

type
  TEvForm = class(TSForm)
    VarCombo: TComboBox;
    VarList: TListBox;
    ValCombo: TComboBox;
    ValList: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    Panel1: TPanel;
    Edit1: TEdit;
    Label3: TLabel;
    Button2: TButton;
    Button3: TButton;
    SB1: TfrSpeedButton;
    SB2: TfrSpeedButton;
    procedure VarComboClick(Sender: TObject);
    procedure ValComboClick(Sender: TObject);
    procedure VarListClick(Sender: TObject);
    procedure ValListClick(Sender: TObject);
    procedure Edit1Exit(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure SB1Click(Sender: TObject);
    procedure SB2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    function CurVar:String;
    function CurVal:String;
    function CurDataSet:String;
    procedure GetFields(Value:String);
    procedure GetSpecValues;
    procedure FillVarCombo;
    procedure FillValCombo;
    procedure ShowVarValue(Value:String);
    procedure SetValTo(Value:String);
    procedure CheckForExpr;
    procedure PostVal;
  public
    { Public declarations }
    Doc: TfrReport;
    Str: TMemoryStream;
    Sl: TStringList;
    procedure Init;
    procedure RefreshVarList(Memo:TStrings);
    procedure CancelChanges;
  end;

var
  EvForm: TEvForm;

{$IFDEF Delphi4}
procedure ShowEvEditor(Component:TfrReport; Designr:IFormDesigner);
{$ELSE}
procedure ShowEvEditor(Component:TfrReport; Designr:TFormDesigner);
{$ENDIF}

implementation

{$R *.DFM}

uses FR_Vared;

var
  SMemo: TStringList;
  VarClipbd: TMemoryStream;

{$IFDEF Delphi4}
procedure ShowEvEditor(Component:TfrReport; Designr:IFormDesigner);
{$ELSE}
procedure ShowEvEditor(Component:TfrReport; Designr:TFormDesigner);
{$ENDIF}
begin
  with TEvForm.Create(nil) do
  try
    Doc := Component;
    Str := TMemoryStream.Create;
    Sl := TStringList.Create;
    Doc.Values.WriteBinaryData(Str);
    Sl.Assign(Doc.Variables);
    Init;
    SB2.Enabled := VarClipbd.Size <> 0;
    if ShowModal = mrOk then
    begin
      if Designr <> nil then
        Designr.Modified
    end
    else
      CancelChanges;
  finally
    Str.Free;
    Sl.Free;
    Free;
  end
end;

procedure TEvForm.Button3Click(Sender: TObject);
begin
  with TVaredForm.Create(nil) do
  try
    Doc := Self.Doc;
    if ShowModal = mrOk then
      RefreshVarList(Memo1.Lines);
  finally
    Free;
  end
end;

procedure TEvForm.Init;
begin
  FillVarCombo;
  FillValCombo;
  VarCombo.ItemIndex := 0;
  ValCombo.ItemIndex := 0;
  VarComboClick(nil);
  ValComboClick(nil);
  CheckForExpr;
end;

procedure TEvForm.RefreshVarList(Memo:TStrings);
var i,j,n: Integer;
    l: TStringList;
begin
  l := TStringList.Create;
  Doc.Variables.Assign(Memo);
  with Doc.Values do
  for i := Items.Count-1 downto 0 do
    if Doc.FindVariable(Items[i]) = -1 then
    begin
      Objects[i].Free;
      Items.Delete(i);
    end;
  Doc.GetCategoryList(l);
  n := l.Count;
  for i := 0 to n-1 do
  begin
    Doc.GetVarList(i,l);
    for j := 0 to l.Count-1 do
      with Doc.Values do
      if FindVariable(l[j]) = nil then
        Items[AddValue] := l[j];
  end;
  FillVarCombo;
  VarCombo.ItemIndex := 0;
  VarComboClick(nil);
  l.Free;
end;

procedure TEvForm.CancelChanges;
begin
  Str.Position := 0;
  Doc.Values.ReadBinaryData(Str);
  Doc.Variables.Assign(Sl);
end;

function TEvForm.CurVar:String;
begin
  Result := '';
  if VarList.ItemIndex <> -1 then
    Result := VarList.Items[VarList.ItemIndex];
end;

function TEvForm.CurVal:String;
begin
  Result := '';
  if ValList.ItemIndex <> -1 then
    Result := ValList.Items[ValList.ItemIndex];
end;

function TEvForm.CurDataSet:String;
begin
  Result := '';
  if ValCombo.ItemIndex <> -1 then
    Result := ValCombo.Items[ValCombo.ItemIndex];
end;

procedure TEvForm.FillVarCombo;
begin
  Doc.GetCategoryList(VarCombo.Items);
end;


procedure TEvForm.FillValCombo;
var i: Integer;
    s: TStringList;
procedure EnumDataSets(f:TComponent);
var i: Integer;
    c: TComponent;
begin
  for i := 0 to f.ComponentCount-1 do
  begin
    c := f.Components[i];
    if c is TDataSet then
      if f = Doc.Owner then
        s.Add(c.Name) else
        s.Add(f.Name + '.' + c.Name);
  end;
end;
begin
  s := TStringList.Create;
  for i := 0 to Screen.FormCount-1 do
    EnumDataSets(Screen.Forms[i]);
  for i := 0 to Screen.DataModuleCount-1 do
    EnumDataSets(Screen.DataModules[i]);
  s.Sort;
  s.Add(frLoadStr('SSpecVal'));
  ValCombo.Items.Assign(s);
  s.Free;
end;

procedure TEvForm.VarComboClick(Sender: TObject);
begin
  Doc.GetVarList(VarCombo.ItemIndex,VarList.Items);
end;

procedure TEvForm.ValComboClick(Sender: TObject);
begin
  if CurDataSet <> frLoadStr('SSpecVal') then
    GetFields(CurDataSet) else
    GetSpecValues;
end;

procedure TEvForm.VarListClick(Sender: TObject);
begin
  ShowVarValue(CurVar);
end;

procedure TEvForm.GetFields(Value: String);
var DataSet: TDataSet;
    i: Integer;
begin
  ValList.Items.Clear;
  ValList.Items.Add(frLoadStr('SNotAssigned'));
  CurReport := Doc;
  DataSet := frGetDataSet(Value);
  if DataSet <> nil then
  with DataSet do
  begin
    FieldDefs.Update;
    if FieldCount > 0 then
      for i := 0 to FieldCount-1 do
        ValList.Items.Add(Fields[i].FieldName)
    else
      for i := 0 to FieldDefs.Count-1 do
        ValList.Items.Add(FieldDefs.Items[i].Name);
  end;
end;

procedure TEvForm.GetSpecValues;
var i: Integer;
begin
  with ValList.Items do
  begin
    Clear;
    Add(frLoadStr('SNotAssigned'));
    for i := 0 to frSpecCount-1 do
      Add(frSpecArr[i]);
  end;
end;

procedure TEvForm.ShowVarValue(Value:String);
begin
  with Doc.Values.FindVariable(Value) do
    case Typ of
      vtNotAssigned:
        SetValTo(CurDataSet + '.' + frLoadStr('SNotAssigned'));
      vtDBField:
        SetValTo(DataSet + '.' + Field);
      vtOther:
        begin
          SetValTo(frLoadStr('SSpecVal') + '.' + frSpecArr[OtherKind]);
          if OtherKind = 1 then
            Edit1.Text := Field;
        end;
    end;
end;

procedure TEvForm.SetValTo(Value:String);
var s1,s2,s3: String;
    i,j: Integer;
begin
  s1 := Copy(Value, 1, Pos('.', Value) - 1);
  s2 := Copy(Value, Pos('.', Value) + 1, 255);
  if Pos('.', s2) <> 0 then
  begin
    s3 := Copy(s2, Pos('.', s2) + 1, 255);
    s2 := Copy(s2, 1, Pos('.', s2) - 1);
    s1 := s1 + '.' + s2;
    s2 := s3;
  end;
  with ValCombo do
  for i := 0 to Items.Count-1 do
    if Items[i] = s1 then
    begin
      if ItemIndex <> i then
      begin
        ItemIndex := i;
        ValComboClick(nil);
      end;
      with ValList do
      for j := 0 to Items.Count-1 do
        if Items[j] = s2 then
        begin
          ItemIndex := j;
          break;
        end;
      break;
    end;
  CheckForExpr;
end;

procedure TEvForm.ValListClick(Sender: TObject);
begin
  if VarList.ItemIndex < 0 then Exit;
  CheckForExpr;
end;

procedure TEvForm.CheckForExpr;
begin
  Edit1.Enabled := (CurDataSet = frLoadStr('SSpecVal')) and
    (CurVal = frSpecArr[1]);
  Label3.Enabled := Edit1.Enabled;
  if not Edit1.Enabled then
  begin
    Edit1.Text := '';
    Edit1.Color := clBtnFace;
  end
  else Edit1.Color := clWindow;
end;

procedure TEvForm.Edit1Exit(Sender: TObject);
begin
  PostVal;
end;

procedure TEvForm.PostVal;
var Val: TfrValue;
    i: Integer;
    s: String;
begin
  Val := Doc.Values.FindVariable(CurVar);
  if Val <> nil then
  with Val do
  begin
    if CurVal = frLoadStr('SNotAssigned') then
      Typ := vtNotAssigned
    else if CurDataSet = frLoadStr('SSpecVal') then
    begin
      Typ := vtOther;
      s := CurVal;
      for i := 0 to frSpecCount-1 do
        if s = frSpecArr[i] then
        begin
          OtherKind := i;
          if i = 1 then // SExpr
            Field := Edit1.Text;
          break;
        end;
    end
    else
    begin
      Typ := vtDBField;
      DataSet := CurDataSet;
      Field := CurVal;
      OtherKind := 0;
    end;
  end;
end;

procedure TEvForm.SB1Click(Sender: TObject);
begin
  VarClipbd.Position := 0;
  Doc.Values.WriteBinaryData(VarClipbd);
  SMemo.Assign(Doc.Variables);
  frWriteMemo(VarClipbd, SMemo);
  SB2.Enabled := True;
end;

procedure TEvForm.SB2Click(Sender: TObject);
begin
  VarClipbd.Position := 0;
  Doc.Values.ReadBinaryData(VarClipbd);
  frReadMemo(VarClipbd, SMemo);
  Doc.Variables.Assign(SMemo);
  Init;
end;

procedure TEvForm.Button1Click(Sender: TObject);
begin
  PostVal;
end;

initialization
  SMemo := TStringList.Create;
  VarClipbd := TMemoryStream.Create;

finalization
  SMemo.Free;
  VarClipbd.Free;

end.
