
{*****************************************}
{                                         }
{             FastReport v2.2             }
{               Fields list               }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}

unit FR_Flds;

interface

{$I FR_Vers.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DB, FR_Utils;

type
  TFieldsForm = class(TSForm)
    ValCombo: TComboBox;
    ValList: TListBox;
    Label1: TLabel;
    procedure ValComboClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ValListClick(Sender: TObject);
  private
    { Private declarations }
    function CurVal:String;
    function CurDataSet:String;
    procedure GetFields(Value:String);
    procedure GetSpecValues;
    procedure FillValCombo;
  public
    { Public declarations }
    DBField: String;
  end;

var
  FieldsForm: TFieldsForm;

implementation

{$R *.DFM}

uses FR_Class;


procedure TFieldsForm.FormActivate(Sender: TObject);
begin
  FillValCombo;
  ValCombo.ItemIndex := 0;
  ValComboClick(nil);
end;

function TFieldsForm.CurVal:String;
begin
  Result := '';
  if ValList.ItemIndex <> -1 then
    Result := ValList.Items[ValList.ItemIndex];
end;

function TFieldsForm.CurDataSet:String;
begin
  Result := '';
  if ValCombo.ItemIndex <> -1 then
    Result := ValCombo.Items[ValCombo.ItemIndex];
end;

procedure TFieldsForm.FillValCombo;
var i: Integer;
    s: TStringList;
procedure EnumDataSets(f:TComponent);
var i: Integer;
    c: TComponent;
begin
  for i := 0 to f.ComponentCount-1 do
  begin
    c := f.Components[i];
    if c is TDataSet then
      if f = CurReport.Owner then
        s.Add(c.Name) else
        s.Add(f.Name + '.' + c.Name);
  end;
end;
begin
  s := TStringList.Create;
  for i := 0 to Screen.FormCount-1 do
    EnumDataSets(Screen.Forms[i]);
  for i := 0 to Screen.DataModuleCount-1 do
    EnumDataSets(Screen.DataModules[i]);
  s.Sort;
  s.Add(frLoadStr('SSpecVal'));
  ValCombo.Items.Assign(s);
  s.Free;
end;

procedure TFieldsForm.ValComboClick(Sender: TObject);
begin
  if CurDataSet <> frLoadStr('SSpecVal') then
    GetFields(CurDataSet) else
    GetSpecValues;
end;

procedure TFieldsForm.GetFields(Value: String);
var DataSet: TDataSet;
    i: Integer;
begin
  ValList.Items.Clear;
  ValList.Items.Add(frLoadStr('SNotAssigned'));
  DataSet := frGetDataSet(Value);
  with DataSet do
  begin
    FieldDefs.Update;
    if FieldCount > 0 then
      for i := 0 to FieldCount-1 do
        ValList.Items.Add(Fields[i].FieldName)
    else
      for i := 0 to FieldDefs.Count-1 do
        ValList.Items.Add(FieldDefs.Items[i].Name);
  end;
end;

procedure TFieldsForm.GetSpecValues;
var i: Integer;
begin
  with ValList.Items do
  begin
    Clear;
    Add(frLoadStr('SNotAssigned'));
    for i := 0 to frSpecCount-1 do
      if i <> 1 then
        Add(frSpecArr[i]);
  end;
end;


procedure TFieldsForm.ValListClick(Sender: TObject);
begin
  if CurVal = frLoadStr('SNotAssigned') then
    ModalResult := mrCancel
  else
  begin
    if CurDataSet <> frLoadStr('SSpecVal') then
      DBField := CurDataSet + '."' + CurVal + '"'
    else
      if ValList.ItemIndex > 1 then
        DBField := frSpecFuncs[ValList.ItemIndex] else
        DBField := frSpecFuncs[0];
    ModalResult := mrOk;
  end;
end;

end.

