
{*****************************************}
{                                         }
{             FastReport v2.2             }
{            Registration unit            }
{                                         }
{  Copyright (c) 1998-99 by Tzyganenko A. }
{                                         }
{*****************************************}


unit FR_reg;

interface

{$I FR_Vers.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  DsgnIntf, DB, Dialogs, FR_Class, FR_Ev_ed, FR_Newrp, FR_DSet, FR_DBSet,
  FR_OLE, FR_Rich, FR_FMemo, FR_Desgn, FR_Dock, FR_Ctrls, FR_Utils;

procedure Register;

implementation

{-----------------------------------------------------------------------}
type
  TVarEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure DoCreateNew;
    procedure DoCreateTempl;
    procedure DoOpen;
    procedure DoDesign;
    procedure DoPreview;
  end;

procedure TVarEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0: ShowEvEditor(TfrReport(Component), Designer);
    1,5: ;
    2: DoCreateNew;
    3: DoCreateTempl;
    4: DoOpen;
    6: DoDesign;
    7: DoPreview;
  end;
end;

function TVarEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := frLoadStr('SVarEditor');
    1,5: Result := '-';
    2: Result := frLoadStr('SNewReport');
    3: Result := frLoadStr('SNewFromTemplate');
    4: Result := frLoadStr('SOpenReport');
    6: Result := frLoadStr('SDesignReport');
    7: Result := frLoadStr('SPreviewReport');
  end;
end;

function TVarEditor.GetVerbCount: Integer;
begin
  Result := 8;
end;

procedure TVarEditor.DoCreateNew;
begin
  TfrReport(Component).Pages.Clear;
  TfrReport(Component).DesignReport;
end;

procedure TVarEditor.DoCreateTempl;
begin
  TemplForm := TTemplForm.Create(nil);
  with TemplForm do
  if ShowModal = mrOk then
  begin
    TfrReport(Component).LoadTemplate(TemplName,nil,nil,True);
    TfrReport(Component).DesignReport;
  end;
  TemplForm.Free;
end;

procedure TVarEditor.DoOpen;
var od: TOpenDialog;
begin
  od := TOpenDialog.Create(nil);
  od.Filter := frLoadStr('SFormFile') + ' (*.frf)|*.frf';
  if od.Execute then
  begin
    TfrReport(Component).LoadFromFile(od.Filename);
    TfrReport(Component).DesignReport;
  end;
  od.Free;
end;

procedure TVarEditor.DoDesign;
begin
  TfrReport(Component).DesignReport;
end;

procedure TVarEditor.DoPreview;
begin
  TfrReport(Component).ShowReport;
end;

{-----------------------------------------------------------------------}
type
  TValuesProperty = class(TPropertyEditor)
  public
    function GetValue: string; override;
    function GetAttributes: TPropertyAttributes; override;
    procedure Edit; override;
  end;

function TValuesProperty.GetValue: string;
begin
  Result := Format('(%s)', [TfrValues.ClassName]);
end;

function TValuesProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog];
end;

procedure TValuesProperty.Edit;
begin
  ShowEvEditor(TfrReport(GetComponent(0)), Designer);
end;

{-----------------------------------------------------------------------}
procedure Register;
begin
  RegisterComponents('FastReport',[TfrReport,TfrCompositeReport,
    TfrDBDataSet,TfrUserDataset,
    TfrOLEObject,TfrRichObject,TfrFramedMemoObject,TfrDesigner]);
  RegisterComponents('FR tools',[TfrSpeedButton,TfrDock,TfrToolBar,
    TfrTBButton,TfrTBSeparator,TfrTBPanel]);
  RegisterComponentEditor(TfrReport, TVarEditor);
  RegisterPropertyEditor(TypeInfo(TfrValues), TfrReport, 'Values', TValuesProperty);
end;

end.
